/*
dd if=/dev/zero of=/tmp/x bs=10k count=10000
gcc -D_REENTRANT -lrt ioperf.c && ./a.out /tmp/x 2 20
*/

#define __USE_UNIX98

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <limits.h> /* PATH_MAX */

#include <fcntl.h> /* or try unixio */
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <pthread.h> /* threaded crashtest */
#define __USE_GNU
#include <aio.h>


#define P 16
// #define S 1024
#define S 8192

char b[P][S];
struct aiocb a[P];
const struct aiocb *pa[P];
struct aioinit ai = { 16, 16, 0,0,0,0, 60 };
int mode = 0;
int trep = 100;
int fd, max;

struct t {
	pthread_t t;
	int       pid;
	int       id;
	int       d,f;
} p[P];

/* (p)thread routine */
static void * run ( void *arg ) {
	struct t *my = (struct t *)arg;
	int fid = dup( fd );
	int i;
	for ( i=0; i<trep/P; i++ ) {
		int blk = (mode&1 ? ((int)rand()) : P*i + my->id) % max;
		int off = blk*S;
		if ( S == pread( fid, b[0], S, off ) )
			my->d++;
		else
			my->f++;
	}
	return NULL;
}

int main ( int argc, char **argv ) {
	struct stat s;
	struct timeval t0, t1, t2;
	int u, i, did = 0, fail = 0, susp = 0;

	if ( 2 < argc )
		mode = atoi( argv[2] );
	if ( 3 < argc )
		trep = atoi( argv[3] );
	trep *= 1000;

	fd = open( argv[1], O_RDONLY );
	fstat( fd, &s );
	max = s.st_size / S;
	
	memset( a, 0, sizeof(a) );
	for ( i=P; i--; ) {
		a[i].aio_fildes = fd;
		a[i].aio_buf = b[i];
		a[i].aio_nbytes = S;
		a[i].aio_sigevent.sigev_notify = SIGEV_NONE;
		/*
		a[i].aio_sigevent.sigev_notify = SIGEV_SIGNAL;
		a[i].aio_sigevent.sigev_signo = SIGIO;
		a[i].aio_sigevent.sigev_value.sival_ptr = &a[i];
		*/
		pa[i] = &a[i];
	}
	if ( 1 == (mode & ~1) )
		aio_init( &ai );

	gettimeofday( &t0, NULL );
	t1 = t0;
	i = 0;

	if ( 4 == (mode & ~1) ) {
		for ( i=0; i<P; i++ ) {
			p[i].id = i;
			if ( pthread_create( &p[i].t, NULL, run, &p[i] ) )
				perror( "pthread_create" );
		}
		for ( i=P; i--; ) {
			pthread_join( p[i].t, NULL );
			did += p[i].d;
			fail += p[i].f;
		}
	} else if ( 6 == (mode & ~1) ) {
		for ( i=0; i<P; i++ ) {
			int seed = rand();
			p[i].id = i;
			if ( ! (p[i].pid = fork()) ) {
				srand( seed );
				run( &p[i] );
				exit( 0 );
			}
		}
		for ( i=P; i--; ) {
			int status;
			wait( &status );
			did += trep/P;
			fail += 0;
		}
	} else while ( did < trep ) {
		int blk = (mode&1 ? ((int)rand()) : did) % max;
		int off = blk*S;

		switch ( mode & ~1 ) {
		case 2:
			{
				/* find free cb */
				int j = i, nop = 1;
				if ( i >= P ) for ( ;; j++ ) {
					if ( i+P == j ) { /* checked all -- wait */
						if ( aio_suspend( pa, P, NULL ) ) {
							perror( "aio_suspend" );
							exit(1);
						}
						susp++;
						j = i;
					}
					switch ( aio_error( &a[j%P] ) ) {
					case EINPROGRESS: continue;
					case ENOSYS:
						perror( "aio_error" );
						exit(1);
					case 0:
						if ( S == aio_return(&a[j%P]) )
							did++;
						else
							fail++;
						nop = 0;
					}
					break;
				}
				j %= P;
				a[j].aio_offset = off;
				if ( aio_read( &a[j] ) ) {
					perror( "aio_read" );
					exit(1);
				}
				i = j+1;
				if ( nop )
					continue;
			}
			break;
		default:
			if ( S == pread( fd, b[0], S, off ) )
				did++;
			else
				fail++;
		}

		if ( ! (did % 1000) && did ) {
			gettimeofday( &t2, NULL );
			u = t2.tv_usec - t1.tv_usec + (t2.tv_sec - t1.tv_sec)*1000000;
			printf( "%d.%06d %d %d %d\n", u / 1000000, u % 1000000, did, fail, susp );
			t1 = t2;
		}
	}
	gettimeofday( &t2, NULL );
	u = t2.tv_usec - t0.tv_usec + (t2.tv_sec - t0.tv_sec)*1000000;
	printf( "\n%d.%06d mode %d did %d fail %d susp %d throughput %d/sec\n",
		u / 1000000, u % 1000000, mode, did, fail, susp,
		1000 * did / (u / 1000) );
	return 0;
}
