/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */
#ifndef LLL_H

/*
	$Id: lll.h,v 1.1 2003/03/03 10:39:07 kripke Exp $
	64 bit integers
*/

#ifdef __GNUC__
#	define LLL_BUILTIN long long
#	define LLL( v ) v##LL
#elif defined( _MSC_VER ) || defined( __BORLANDC__ )
#	define LLL_BUILTIN __int64
#	define LLL( v ) v /* is there some special suffix ??? */
#elif 0xFFFFFFFFL != ~0L
#	define LLL_BUILTIN long
#	define LLL( v ) v##L
#endif

#ifndef LLL_BUILTIN
#	error "please use a compiler providing a 64 bit integer type. thanks."
#endif

typedef LLL_BUILTIN lll;

#define LLL_H
#endif /* LLL_H */
