/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */
#ifndef LSES_H

/*
	$Id: lses.h,v 1.6 2003/03/24 21:03:55 kripke Exp $
	session
*/

#include "loi.h"
#include "lio.h"

enum {
	LSES_FILE_MAX = 16
};

typedef struct Ses {
	int          id;
	struct Ses  *nxt; /* chain in hash */
	int          hash; /* -value of name */
	char         name[64];
	int          accnt; /* # accesses */
	Tm           ctime;
	Tm           mtime;
	Tm           atime;

	Rec         *prop; /* session state */
	Rec         *res; /* a reusable result */
	struct Con  *cur; /* current connection */
	struct Con  *que; /* connection queue */
	Ios         *io[LSES_FILE_MAX];
	/* actually this is followed by internal members ... */
}	Ses;

#ifndef LSES_C
extern Ses lses0; /* the default session */
#endif

/* set up the default session */
extern int lses_init ( Rec *args );


/**
	get or create session by name (of len nlen).
	name will be cleaned of control chars (<32).
	touch atime (and ctime on new) with now (if not 0).
	clean and reuse sessions with atime < expire (if not 0)
*/
extern Ses *cSesByName ( char *name, int nlen, Tm *now, Tm *expire );


#define LSES_H
#endif /* LSES_H */
