/*
openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */


package org.openisis;


/**
	convert OpenIsisRecord to Xml
*/


import java.io.*;
import java.util.*;

public class RecToXml {
	private Fdt myFdt;
	
	public RecToXml(Fdt fdt) {
		myFdt=fdt;	
	}

	public String toXML(Rec rec,String add) {
		return toXML(rec,"",add);
	}

	public String toXML(Rec rec,String pre,String add) {
	  StringBuffer xml=new StringBuffer();	
		Field f;
		Rec subRec;
		int subLen;
		int i=0;
		String lastTag=null;
		String h;
		while(i<rec.getLen()) {
			f=rec.getField(i);
			if (f.tag==Integer.MAX_VALUE) {
				//unwrap it
				subLen=new Integer(f.val).intValue();
				subRec=new Rec(0,rec.getFields(i+1,subLen));
				xml.append((h=toXML(subRec,pre+add)));
				i+=subLen;
				if (lastTag!=null) {
					xml.append("</"+lastTag+">");
					lastTag=null;
				}
			} else {
				if (lastTag!=null) {
					xml.append("</"+lastTag+">");
					lastTag=null;
				}
				if (f!=null && myFdt.fdById(f.tag)!=null) {
				Field sf[]=f.getSubFields();
				String value=f.getValue();
				String atts="";
				if (sf!=null && sf.length>0) {
					atts=atts;
					for(int j=0;j<sf.length;j++) {
						atts=atts+" "+((char)sf[j].tag)+"=\""+sf[j].val+"\"";
					}
					atts=atts+" ";
				}
				lastTag=myFdt.fdById(f.tag).name;
				xml.append(pre+"<"+lastTag+atts+">");
				if (value.indexOf("&")>=0 || value.indexOf("<")>=0) {
				   value="<![CDATA["+value+"]]>";
				}
				xml.append(value);
				}
				//xml.append("</"+myFdt.fdById(f.tag).name+">\n");
			}
			i++;
		}
		if (lastTag!=null) xml.append(pre+"</"+lastTag+">");
		return xml.toString();	
	}
	
}

