/*
openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */


package org.openisis;

/**
 *  some tests
 */

import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;



public class XmlTest {

	public static void main(String argv[]) {
		try {
		XMLReader reader=XMLReaderFactory.createXMLReader();
		XmlToRec x2r=new XmlToRec(reader);
		Rec r=x2r.toRec(new FileReader(argv[0]));
		StringBuffer b=new StringBuffer();
		r.v(b,"","",0,0,0,1000,"\n","");
		System.out.println("R:"+r.getLen()+",\n"+b.toString());
		System.out.println("\nFTD:"+x2r.getFdt().dump());
		RecToXml r2x=new RecToXml(x2r.getFdt());
		String xml1=r2x.toXML(r,"");
		x2r=new XmlToRec(reader);
		Rec r2=x2r.toRec(new StringReader(xml1));
		String xml2=r2x.toXML(r2,"");
			Rec r3=x2r.toRec(new StringReader(xml2));
		String xml3=r2x.toXML(r3,"");
		System.out.println("COMPARE:"+xml3.compareTo(xml2));
		if (xml3.compareTo(xml2)!=0) {
				boolean diff=false;
		   for(int i=0;i<xml1.length() && !diff;i++) {
				 	if (xml2.charAt(i)!=xml3.charAt(i)) {
						System.out.println("DIFF:"+xml2.substring(i,xml2.length()));
						diff=true;
					}
			 }
		}
		PlainSerializer ps = new PlainSerializer( (InputStream)null, System.out );
		System.out.println("\n\nXML2:"+xml2);
		System.out.println("\n\nR2:");
		ps.write( r2.getFields() );
		System.out.println("\n\nXML3:"+xml3);
		System.out.println("\n\nR3:");
		ps.write( r3.getFields() );
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
}
