/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2002 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */

/*
	$Id: isish.c,v 1.2 2003/03/27 14:49:31 kripke Exp $
	OpenIsis Tcl shell
*/


#include "openisis.h"
#include "openisistcl.h"


#ifdef ORATCL
extern int Oratcl_Init ( Tcl_Interp *ip );
#endif


static int appinit ( Tcl_Interp *interp )
{
	if ( TCL_OK != Tcl_Init( interp )
		|| TCL_OK != OpenisisTcl_Init( interp )
#ifdef ORATCL
		|| TCL_OK != Oratcl_Init( interp )
#endif
	)
		return TCL_ERROR;
	return TCL_OK;
}


int main ( int argc, const char **argv )
{
	openIsisCOpen(0);

	Tcl_Main( argc, argv, appinit );
	return 0;
}
