/*
	openisis - an open implementation of the ISIS database
	Version 0.8.x (microversion see file Version)
	Copyright (C) 2001-2003 by Erik Grziwotz, erik@openisis.org

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	This software is dedicated to the memory of Eckart Dietrich.

	This software is inspired by (but contains no code of) the iAPI
	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
	See iAPI.txt for what it contains.
EOH */

/*
	$Id: openisistcl.h,v 1.8 2003/03/31 09:11:57 kripke Exp $
	tcl/tk binding
*/

#ifndef OPENISISTCL
#define OPENISISTCL

#include <tcl.h>

EXTERN int OpenisisTcl_Init _ANSI_ARGS_ ( ( Tcl_Interp *interp ) );

/*
done in w/isish.c
EXTERN int OpenisisTcl_AppInit _ANSI_ARGS_ ( ( Tcl_Interp *interp ) );
*/

/**	@return session id on success, -1 on error
*/
EXTERN int openIsisTclNewSession _ANSI_ARGS_ ( (
	OpenIsisSession ses, Tcl_Interp *ip ) );

/**	@return boolean ok
*/
EXTERN int openIsisTclGetSession _ANSI_ARGS_ ( (
	int sessid, OpenIsisSession *ses, Tcl_Interp **ip ) );

/*
	interface needed by "main-threaded" server:
	- create commands for records "req", "res", "ses"
	- bind Recs to those commands and set "the" session.
		all recs are dynamic and can be assumed to belong to "the" session.
		should be discarded by "the" session when extended.
		the "req" record must not be modified
		(since it's real owner session might be working in parallel).
		modification would require "copy-on-write".
	- retrieve Recs
	future extension:
	the same game with multiple openIsisTclSessions,
	each with one interp (constant) and one OpenIsisSession (per call)
*/
/**
	create record command slot
	on a clean session, ids are guaranteed to increment 0,1 ...
	return slot id >=0 or err <0
*/
EXTERN int openIsisTclCreateRecCmd ( int sid, char *nam, int flg );
/**
	set/get cnt records to/from slots specified by ids
	return cnt or err <0
EXTERN int openIsisTclSetRecs ( int oitses, int cnt,
	const int *ids, OpenIsisRec **recs );
EXTERN int openIsisTclGetRecs ( int oitses, int cnt,
	const int *ids, OpenIsisRec **recs );
*/
/**
	set session to ses and eval command in oitses' interp
	if recs is not 0, set cnt recs as specified by ids
	(as created by openIsisTclCreateRecCmd)
*/
EXTERN int openIsisTclEval ( int sid, OpenIsisSession ses,
	int cnt, const int *ids, OpenIsisRec **recs, char *script );


#endif /* OPENISISTCL */
