#!/opt/openisis/tcl/tclbuild/tclsh
#
#	openisis - an open implementation of the ISIS database
#	Version 0.8.x (microversion see file Version)
#	Copyright (C) 2003 by Erik Grziwotz, erik@openisis.org
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Lesser General Public
#	License as published by the Free Software Foundation; either
#	version 2.1 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Lesser General Public License for more details.
#
#	You should have received a copy of the GNU Lesser General Public
#	License along with this library; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	This software is dedicated to the memory of Eckart Dietrich.
#
#	This software is inspired by (but contains no code of) the iAPI
#	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
#	See iAPI.txt for what it contains.
#
#	$Id: test2.tcl,v 1.1 2003/03/22 12:19:16 mawag Exp $
#	test script for openisis record tcl command

proc putt msg {
	global prnout
	if $prnout {
		puts "$msg"
	}
}

switch $argc {
0 { set nloops 1; set nrecs 1; set prnout 1 }
1 { set nloops [lindex $argv 0]; set nrecs 1; set prnout 0 }
2 { set nloops [lindex $argv 0]; set nrecs [lindex $argv 1]; set prnout 0 }
default {
	set nloops [lindex $argv 0]
	set nrecs [lindex $argv 1]
	set prnout [lindex $argv 2]
}
}

for {} { 0 != $nloops } { incr nloops -1 } {
	set lst ""
	for {set j $nrecs} {0 <= [incr j -1]} {} {
		set cmd [openIsisRec {} set 23232 aa 45454 bb 23232 cc]
		lappend lst $cmd
		set val jdkjgjkdsdsfdffgfdggggggfdfkglfdsjdafdafdsa
		$cmd set 1 $val
		$cmd set 2 $val
		$cmd set 3 $val
		$cmd set 476 $val
		$cmd set 477 $val
		$cmd set 478 $val
		#	73 exhausting mem
		for {set f 1} {72 > $f} {incr f} {
			$cmd set $f njjhrehjghtgthgrthtbrbrthbrtibtrbhjtiobhghbhbkgbt
		}
		$cmd delete 2 {23232[0]} 477
		$cmd add 23232 dd
		putt [$cmd get]
	}
	foreach cmd "$lst" {
		$cmd done
	}
	if {! $prnout && 0 == [expr $nloops % 100]} {
		puts "$nloops ..."
	}
}

puts "ok."

