#!/opt/openisis/tcl/tclbuild/tclsh
#
#	openisis - an open implementation of the ISIS database
#	Version 0.8.x (microversion see file Version)
#	Copyright (C) 2003 by Erik Grziwotz, erik@openisis.org
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Lesser General Public
#	License as published by the Free Software Foundation; either
#	version 2.1 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Lesser General Public License for more details.
#
#	You should have received a copy of the GNU Lesser General Public
#	License along with this library; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	This software is dedicated to the memory of Eckart Dietrich.
#
#	This software is inspired by (but contains no code of) the iAPI
#	Copyright (C) 2000 by Robert Janusz, rj@jezuici.krakow.pl.
#	See iAPI.txt for what it contains.
#
#	$Id: test5.087.tcl,v 1.1 2003/03/06 16:01:47 mawag Exp $
#	test script for tcl-binding of openisis

# openIsisLog v

set ses0 [openIsisInit]

set db [openIsisOpen /opt/openisis/db/cds/cds]

set res [$db query africa -session $ses0]
puts ----------------------------------------------------------------
puts "africa 0 -> [$res list]"
$res close

set res [$db query africa -mode 1 -session $ses0]
puts ----------------------------------------------------------------
puts "africa 1 -> [$res list]"
$res close

set res [$db query africa$ -mode 2 -session $ses0]
puts ----------------------------------------------------------------
puts "africa$ 2 -> [$res list]"
$res close

#	-mode 64 not implemented yet

set res [$db query africa -mode 128 -session $ses0]
puts ----------------------------------------------------------------
puts "africa 128 -> [$res list]"
$res close

#	-mode 129 no effect

set res [$db query universities -mode 0 -session $ses0]
puts ----------------------------------------------------------------
puts "universities 0 -> [$res list]"
$res close

set res [$db query {universities + africa} -mode 128 -session $ses0]
puts ----------------------------------------------------------------
puts "universities+africa 128 -> [$res list]"
$res close

set res [$db query {universities ^ africa} -mode 128 -session $ses0]
puts ----------------------------------------------------------------
puts "universities^africa 128 -> [$res list]"
$res close

set res [$db query {universities africa} -mode 128 -session $ses0]
puts ----------------------------------------------------------------
puts "universities africa 128 -> [$res list]"
$res close

$db close

